#include <algorithm>
#include <cctype>
#include <string>
#include "Vec.h"

#include "hledani_url.h"

using std::find;
using std::find_if;

using std::isalnum;
using std::isalpha;
using std::isdigit;

using std::search;
using std::string;

bool ne_url_znak(char);

string::const_iterator
konec_url(string::const_iterator, string::const_iterator);

string::const_iterator
zacatek_url(string::const_iterator, string::const_iterator);
Vec<string> hledani_url(const string& s)
{
	Vec<string> navrat;
	typedef string::const_iterator iter;
	iter z = s.begin(), k = s.end();

	// prohldne cel vstup
	while (z != k) {

		// hled jeden nebo vce znak nsledovanch etzcem '://'
		z = zacatek_url(z, k);

		// pokud je nalezne
		if (z != k) {
			// zsk zbytek URL
			iter po = konec_url(z, k);

			// zapamatuje si URL
			navrat.push_back(string(z, po));

			// posune 'z' a hled dal adresy URL na tomto dku
			z = po;
		}
	}
	return navrat;
}

string::const_iterator
konec_url(string::const_iterator z, string::const_iterator k)
{
	return find_if(z, k, ne_url_znak);
}

bool ne_url_znak(char c)
{
	// znaky, kter se spolu s alfanumerickmi mohou objevit v adrese URL
	static const string url_zn = "~;/?:@=&$-_.+!*'(),";

	// zjist, zda se 'c' me vyskytnout v adrese URL a vrt negaci
	return !(isalnum(c) ||
	         find(url_zn.begin(), url_zn.end(), c) != url_zn.end());
}

string::const_iterator
zacatek_url(string::const_iterator z, string::const_iterator k)
{
	static const string odd = "://";

	typedef string::const_iterator iter;

	// 'i' oznauje msto nalezen oddlovae
	iter i = z;

	while ((i = search(i, k, odd.begin(), odd.end())) != k) {

		// zjist, zda oddlova nen na zatku nebo na konci dku
		if (i != z && i + odd.size() != k) {

			// 'zac' oznauje zatek jmna protokolu
			iter zac = i;
			while (zac != z && isalpha(zac[-1]))
				--zac;

			// nachz se ped a za oddlovaem alespo jeden ppustn znak?
			if (zac != i && !ne_url_znak(i[odd.size()]))
				return zac;
		}

		// nalezen oddlova nebyl soust URL; posune 'i' za tento oddlova
		i += odd.size();
	}
	return k;
}

