#ifndef HLIDAC_stred_h
#define HLIDAC_stred_h

#include <algorithm>
#include <stdexcept>
#include "Vec.h"

using std::domain_error;
using std::sort;

template <class T>
T stred(Vec<T> v)
{
	typedef typename Vec<T>::size_type vec_vel;

	vec_vel velikost = v.size();
	if (velikost == 0)
		throw domain_error("stredni hodnota prazdneho objektu Vec");

	sort(v.begin(), v.end());

	vec_vel pros = velikost/2;

	return velikost % 2 == 0 ? (v[pros] + v[pros-1]) / 2 : v[pros];
}
#endif

