#include <stdexcept>
#include "Vec.h"
#include "znamka.h"
#include "stred.h"
#include "Student_info.h"

using std::domain_error;


// vypot zvrenou znmku studenta ze znmek zkouky v polovin, na zvr kurzu a z domcch kol
double znamka(double polovina, double zaver, double domaciukol)
{
	return 0.2 * polovina + 0.4 * zaver + 0.4 * domaciukol;
}

// vypot zvrenou znmku studenta ze znmek zkouky v polovin, na zvr kurzu
// a vektoru 'Vec' znmek domacch kol
// tato funkce nekopruje svj argument, protoe to pro ns dl funkce 'stred'
double znamka(double polovina, double zaver, const Vec<double>& du)
{
	if (du.size() == 0)
		throw domain_error("student neudelal zadny domaci ukol");
	return znamka(polovina, zaver, stred(du));
}

double znamka(const Student_info& s)
{
	return znamka(s.polovina, s.zaver, s.domaciukol);
}